diff -r 779c5a44c6a1 .hgtags
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/.hgtags	Wed Dec 16 19:19:57 2009 +0100
@@ -0,0 +1,5 @@
+b40dd43fc1f27083cf2696c57ec6b907855fb007 IS2.0-beta1
+4cd407daac0d6fbaa012ef49eec43ffaf32bb207 IS2.0-beta2
+56a047d6bab4807fe6d89dd8bdc2edbc4e6c7ad4 IS2.0-beta3
+2d98b8a58b405fd24f84f27446b6d370b22bbf29 IS2.0-beta4
+1767ebc9758c27634714f1a667fd1e3f0e3fdc3e IS2.0-beta5
diff -r 779c5a44c6a1 backup.push
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/backup.push	Wed Dec 16 19:19:57 2009 +0100
@@ -0,0 +1,1 @@
+ssh://hg@bitbucket.org/OpenTTD/infrastructure-sharing/
diff -r 779c5a44c6a1 projects/openttd_vs80.vcproj
--- a/projects/openttd_vs80.vcproj	Fri Dec 04 22:02:37 2009 +0000
+++ b/projects/openttd_vs80.vcproj	Wed Dec 16 19:19:57 2009 +0100
@@ -584,6 +584,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini.cpp"
 				>
 			</File>
@@ -1072,6 +1076,14 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure_func.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini_type.h"
 				>
 			</File>
diff -r 779c5a44c6a1 projects/openttd_vs90.vcproj
--- a/projects/openttd_vs90.vcproj	Fri Dec 04 22:02:37 2009 +0000
+++ b/projects/openttd_vs90.vcproj	Wed Dec 16 19:19:57 2009 +0100
@@ -581,6 +581,10 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.cpp"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini.cpp"
 				>
 			</File>
@@ -1069,6 +1073,14 @@
 				>
 			</File>
 			<File
+				RelativePath=".\..\src\infrastructure.h"
+				>
+			</File>
+			<File
+				RelativePath=".\..\src\infrastructure_func.h"
+				>
+			</File>
+			<File
 				RelativePath=".\..\src\ini_type.h"
 				>
 			</File>
diff -r 779c5a44c6a1 source.list
--- a/source.list	Fri Dec 04 22:02:37 2009 +0000
+++ b/source.list	Wed Dec 16 19:19:57 2009 +0100
@@ -31,6 +31,7 @@
 gfxinit.cpp
 heightmap.cpp
 highscore.cpp
+infrastructure.cpp
 ini.cpp
 landscape.cpp
 map.cpp
@@ -177,6 +178,8 @@
 industry.h
 industry_type.h
 industrytype.h
+infrastructure.h
+infrastructure_func.h
 ini_type.h
 landscape.h
 landscape_type.h
diff -r 779c5a44c6a1 src/aircraft_cmd.cpp
--- a/src/aircraft_cmd.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/aircraft_cmd.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -35,6 +35,7 @@
 #include "effectvehicle_func.h"
 #include "station_base.h"
 #include "cargotype.h"
+#include "infrastructure_func.h"
 
 #include "table/strings.h"
 #include "table/sprites.h"
@@ -113,7 +114,7 @@
 	const AircraftVehicleInfo *avi = AircraftVehInfo(v->engine_type);
 
 	FOR_ALL_STATIONS(st) {
-		if (st->owner != v->owner || !(st->facilities & FACIL_AIRPORT)) continue;
+		if (!(st->facilities & FACIL_AIRPORT) || !IsInfraUsageAllowed(st->owner, v)) continue;
 
 		const AirportFTAClass *afc = st->Airport();
 		if (afc->nof_depots == 0 || (
@@ -144,7 +145,7 @@
 
 	FOR_VEHICLE_ORDERS(v, order) {
 		const Station *st = Station::Get(order->station);
-		if (st->owner == v->owner && (st->facilities & FACIL_AIRPORT)) {
+		if (IsInfraUsageAllowed(st->owner, v) && (st->facilities & FACIL_AIRPORT)) {
 			/* If an airport doesn't have a hangar, skip it */
 			if (st->Airport()->nof_depots != 0)
 				return true;
@@ -247,7 +248,7 @@
 	/* to just query the cost, it is not neccessary to have a valid tile (automation/AI) */
 	if (flags & DC_QUERY_COST) return value;
 
-	if (!IsHangarTile(tile) || !IsTileOwner(tile, _current_company)) return CMD_ERROR;
+	if (!IsHangarTile(tile) || !CheckInfraUsageAllowed(tile, VEH_AIRCRAFT)) return CMD_ERROR;
 
 	/* Prevent building aircraft types at places which can't handle them */
 	if (!CanVehicleUseStation(p1, Station::GetByTile(tile))) return CMD_ERROR;
@@ -1569,7 +1570,7 @@
 	/* runway busy or not allowed to use this airstation, circle */
 	if ((apc->flags & (v->subtype == AIR_HELICOPTER ? AirportFTAClass::HELICOPTERS : AirportFTAClass::AIRPLANES)) &&
 			st->airport_tile != INVALID_TILE &&
-			(st->owner == OWNER_NONE || st->owner == v->owner)) {
+			IsInfraUsageAllowed(st->owner, v)) {
 		/* {32,FLYING,NOTHING_block,37}, {32,LANDING,N,33}, {32,HELILANDING,N,41},
 		 * if it is an airplane, look for LANDING, for helicopter HELILANDING
 		 * it is possible to choose from multiple landing runways, so loop until a free one is found */
diff -r 779c5a44c6a1 src/command.cpp
--- a/src/command.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/command.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -199,6 +199,7 @@
 DEF_COMMAND(CmdSetVehicleOnTime);
 DEF_COMMAND(CmdAutofillTimetable);
 DEF_COMMAND(CmdSetTimetableStart);
+DEF_COMMAND(CmdChangeSharingSetting);
 #undef DEF_COMMAND
 
 /**
@@ -345,6 +346,7 @@
 	{CmdSetVehicleOnTime,                           0}, // CMD_SET_VEHICLE_ON_TIME
 	{CmdAutofillTimetable,                          0}, // CMD_AUTOFILL_TIMETABLE
 	{CmdSetTimetableStart,                          0}, // CMD_SET_TIMETABLE_START
+	{CmdChangeSharingSetting,                       0}, // CMD_CHANGE_SHARING_SETTING
 };
 
 /*!
diff -r 779c5a44c6a1 src/command_type.h
--- a/src/command_type.h	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/command_type.h	Wed Dec 16 19:19:57 2009 +0100
@@ -294,6 +294,7 @@
 	CMD_SET_VEHICLE_ON_TIME,          ///< set the vehicle on time feature (timetable)
 	CMD_AUTOFILL_TIMETABLE,           ///< autofill the timetable
 	CMD_SET_TIMETABLE_START,          ///< set the date that a timetable should start
+	CMD_CHANGE_SHARING_SETTING,       ///< change one of the settings for infrastructure sharing
 };
 
 /**
diff -r 779c5a44c6a1 src/company_base.h
--- a/src/company_base.h	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/company_base.h	Wed Dec 16 19:19:57 2009 +0100
@@ -23,6 +23,7 @@
 #include "economy_type.h"
 #include "tile_type.h"
 #include "settings_type.h"
+#include "infrastructure.h"
 
 struct CompanyEconomyEntry {
 	Money income;
@@ -87,6 +88,12 @@
 	CompanySettings settings;          ///< settings specific for each company
 	uint16 *num_engines; ///< caches the number of engines of each type the company owns (no need to save this)
 
+	byte sharing_delay;                     ///< number of months before new settings go in effect
+	CompanySharingSettings sharing_current; ///< settings currently in effect
+	CompanySharingSettings sharing_future;  ///< future settings, will go in effect after (sharing_delay) months.
+	Date sharing_setting_change_news_date;  ///< NOSAVE: date when a news message regarding an announced change of sharing settings was issued of the last time
+	Date sharing_insolvency_news_date;      ///< NOSAVE: date when a news message regarding insolvency was issued for the last time
+
 	static FORCEINLINE bool IsValidAiID(size_t index)
 	{
 		const Company *c = Company::GetIfValid(index);
diff -r 779c5a44c6a1 src/company_cmd.cpp
--- a/src/company_cmd.cpp	Fri Dec 04 22:02:37 2009 +0000
+++ b/src/company_cmd.cpp	Wed Dec 16 19:19:57 2009 +0100
@@ -75,6 +75,7 @@
 	InvalidateWindowData(WC_GRAPH_LEGEND, 0, (int)index);
 	InvalidateWindowData(WC_PERFORMANCE_DETAIL, 0, (int)index);
 	InvalidateWindowData(WC_COMPANY_LEAGUE, 0, 0);
+	InvalidateWindowClassesData(WC_SHARING_OPTIONS, 1);
 }
 
 /**
@@ -178,14 +179,16 @@
 	if (HasBit(1 << EXPENSES_TRAIN_INC    |
 	           1 << EXPENSES_ROADVEH_INC  |
 	           1 << EXPENSES_AIRCRAFT_INC |
-	           1 << EXPENSES_SHIP_INC, cost.GetExpensesType())) {
+	           1 << EXPENSES_SHIP_INC     |
+	           1 << EXPENSES_SHARED_INC, cost.GetExpensesType())) {
 		c->cur_economy.income -= cost.GetCost();
 	} else if (HasBit(1 << EXPENSES_TRAIN_RUN    |
 	                  1 << EXPENSES_ROADVEH_RUN  |
 	                  1 << EXPENSES_AIRCRAFT_RUN |
 	                  1 << EXPENSES_SHIP_RUN     |
 	                  1 << EXPENSES_PROPERTY     |
-	                  1 << EXPENSES_LOAN_INT, cost.GetExpensesType())) {
+	                  1 << EXPENSES_LOAN_INT     |
+	                  1 << EXPENSES_SHARED_RUN, cost.GetExpensesType())) {
 		c->cur_economy.expenses -= cost.GetCost();
 	}
 
@@ -463,11 +466,28 @@
 
 	SetDefaultCompanySettings(c->index);
 
+	/* sharing settings */
+	if (_settings_game.sharing.sharing_mode == SHARING_GLOBAL) {
+		c->sharing_current.CopyFromGameSettings();
+		c->sharing_future = c->sharing_current;
+		/* enable this company in all companies */
+		Company *d;
+		FOR_ALL_COMPANIES(d) {
+			d->sharing_current.SetCompanyAllowed(c->index, true);
+			d->sharing_future.SetCompanyAllowed(c->index, true);
+		}
+	} else {
+		/* only allow own company */
+		c->sharing_current.SetCompanyAllowed(c->index, true);
+		c->sharing_future.SetCompanyAllowed(c->index, true);
+	}
+
 	GeneratePresidentName(c);
 
 	SetWindowDirty(WC_GRAPH_LEGEND, 0);
 	SetWindowDirty(WC_TOOLBAR_MENU, 0);
 	SetWindowDirty(WC_CLIENT_LIST, 0);
+	InvalidateWindowClassesData(WC_SHARING_OPTIONS, 1);
 
 	if (is_ai && (!_networking || _network_server)) AI::StartNew(c->index);
 
